{
********************************************************
*          DBase III - TPascal 5.0 interface           *
*          Produced by Yudin Andrey (C),1989           *
*                     Version 2.0                      *
********************************************************
}

{
********************************************************
PP    (dbf) DBASE-3


         ঠ       祭
0            1 byte            ᨨ DBASE-3
                              (03 -  .dbt 䠩,
                               83 -  .dbt 䠩)

1-3          3 bytes        ᫥  
															(YY MM DD)
4-7          32 bit         ᫮ ᥩ  䠩
             numbers
8-9          16 bit           
             numbers
10-11        16 bit          ᥩ
             numbers
12-31        20 bytes       १ࢨ஢ (v.1.0)
32-n         32 bytes       ᨢ ᠭ 
             each
n+1          1 bytes        ODH - 殢 ᨢ

ᠭ 
         ঠ     祭
0-10         11 bytes           ASCII ,
                             ﬨ
11            1 bytes           ASCII
                            (,N,L,D,M)
12-15        32 bit             
             number
16            1 bytes        
17            1 bytes       ᫮  ࠧ冷(only for type D)
18-32        14 bytes       १ࢨ஢ (v.1.0)

ᯮ ᥩ
1   । 1 ,  
  ஡ (20), ᫨   㤠 ,  窠 (2)
  ᫨  㤠.
2  㯠    ࠧ⥫
3  ࠭   ASCII  ᫥饬 ଠ:

                           


                    ASCII ᨬ

           ᫮           -.0123456789

           ᪨         YyNnTtFf

           ਬ砭         10 , ।⠢
                                .dbt
                               p砭 : <dbf->.dbt
                              0  - offset 000h ⭮⥫쭮 砫 䠩
                              1  - offset 200h ,  ..
                               p砭 in dbt-file : code 1Ah (= 26d)

                          8   ଠ YYYYMMDD

***************************************************************}

unit DB3Tool;

interface

uses
	 tpCRT,
   Dos,
   TPMemChk;

type
  MaxFieldNumber             = 1..1000;
  MaxRecNumber               = 1..10000;
  BuferSize                  = 0..65534;

const
  UserErrorHandler : boolean = false;
  AddRecFactor               = 5;
                             {There is no reason to add only one record to
                              Data Base - it's very difficult to do that,
                              so we add AddRecFactor records at time}

type
  Bufer     = array[BuferSize] of byte;
  CharBufer = array[BuferSize] of char;

  FieldName = string[11];
  FieldType = (C,N,L,M,D);

  CType     = string[254];
  NType     = string[19];
  LType     = string[1];
  MType     = string[10];
  DType     = string[8];

  Date = record
     MM : byte;
     DD : byte;
     YY : byte;
   end;

  FieldD = record
     FName   : FieldName;
     FType   : FieldType;
     FLength : byte;
     FDec    : byte;
   end;

  FieldDPtr   = ^FieldD;
  FieldPtr    = ^CharBufer;
  FieldDArray = array[MaxFieldNumber] of FieldD;

  RecPtr      = ^bufer;
  FilePtr     = longint;

  RecordArray = array[MaxRecNumber] of RecPtr;
  RecordFile  = array[MaxRecNumber] of FilePtr;

  DBD = record
    LastUpdate         : Date;
    TotalRecs          : longint;
    UsedRecs           : longint;
    TotalFields        : longint;
    RecSize            : word;
    FieldDArrayPtr     : ^FieldDArray;
    MinRamUsing	       : boolean;
    case byte of
	    0: (RecArrayPtr  : ^RecordArray);
	    1: (CurRec       : RecPtr;
                CurRecNumber : longint;
		TmpFile      : file);
    end;

{

Structure of DBase III data base , loading in memory                     T
      ͻ     ͻ Ŀ  o
DBD =  LastUpdate =  MM  DD  YY   >FNameFTypeFLengthFDec    t
      Ķ    Ķ    a
       TotalRecs                                                l
      Ķ    Ķ   F
       UsedRecs                               .  .  .  .  .        i
      Ķ    Ķ    e
       TotalFields                                              l
      Ķ    ͼ   d
       RecSize                                                        s
      Ķ  
       FieldDArrayPtr               
      Ķ
       RecArrayPtr                  Ŀ
      ͼ  

                 Deleted(*)/Present( ) Marker
                
                Ŀ
                     V
     ͻ    ͻ Ŀ T
> RecPtr1  >  Record1    o
      Ķ    Ķ   t
       RecPtr2  >  Record2    a
      Ķ .. Ķ   l
      Ķ .. Ķ   R
       RecPtrN  >  RecordN    e
      ͼ    ͼ  c
                                      s

}

function  DBErrMsg(DBErr : word) : string;
function  DBResult : word;
procedure SetDBError (ErrN : word);

procedure ReadDB (var DBDescr : DBD;
                  DBFile : string;
                  MinRamUse : boolean);
procedure WriteDB(var DBDescr : DBD; DBFile : string);

procedure CreateDB(var DBDescr : DBD;																TotRecs 	 : longint;
                   var FieldDescr : FieldD;
                   MinRamUse  : boolean);
procedure RemoveDB(var DBDescr : DBD);

procedure AddField(var DBDescr : DBD;var FieldDescr : FieldD);
procedure DeleteField(var DBDescr : DBD;FieldN : longint);

function  AddRec   (var DBDescr : DBD) : longint;
procedure DeleteRec(var DBDescr : DBD;RecN : longint);

function GetFieldPtr (var DBDescr : DBD;RecN : longint;FieldN : longint) : FieldPtr;
function GetFieldDPtr(var DBDescr : DBD;FieldN : longint) : FieldDPtr;
function GetMaxRec   (var DBDescr : DBD) : longint;
function GetMaxField (var DBDescr : DBD) : longint;
function CheckFieldD (var FD : FieldD) : boolean;

function GetField(var DBDescr : DBD;RecN : longint;FieldN : longint) : string;
function GetRField(var DBDescr : DBD;RecN : longint;FieldN : longint) : real;
function GetBField(var DBDescr : DBD;RecN : longint;FieldN : longint) : boolean;
function GetDField(var DBDescr : DBD;RecN : longint;FieldN : longint) : DType;

procedure PutField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : string);
procedure PutRField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : real);
procedure PutBField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : boolean);
procedure PutDField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : DType);

{
     :
  L                 True,False
  N                 LowRange - HighRange
  C                 Equal(+WildCard)
  D                 Equal(+WildCard)

  ⨬ wildcards - ?,*
}

const
  MaxPatrnNumber = 200;

type
  Patrn = record
           CFieldN : longint;
           CFType  : FieldType;
           case byte of
             0     : (LP : boolean);
             1     : (NP : array[1..2] of real);
             2     : (CP : CType);
             3     : (DP : DType);
         end;

  PatrnArray = array[1..MaxPatrnNumber] of Patrn;

  MaskD = record
            TotalPatrn : byte;
            StartRec   : longint;
            DBPtr      : ^DBD;
            PatrnAPtr  : ^PatrnArray;
          end;

procedure CreateMask      (var MD : MaskD;var Pat : Patrn);
procedure DeleteMask      (var MD : MaskD);
procedure AddPatrn        (var MD : MaskD;var Pat : Patrn);
function  FindFirstRecord (var MD : MaskD;var DBDescr : DBD) : longint;
function  FindNextRecord  (var MD : MaskD)               : longint;

implementation

var
  DBError : word;

const
  DB3Id                     = 3;
  EndOfFields   : byte      = $0D;
  EndOfFile     : byte      = byte(^Z);
  RecordPresent : byte      = byte(' ');
  RecordDeleted : byte      = byte('*');
  FieldStrType  : string[5] = 'CNLMD';
  SmallBlockLength          = 32;
  DeltaDate                 = 1;
  DeltaTotalRecs            = 4;
  DeltaHeaderLength         = 8;
  DeltaRecordsLength        = 10;
  DeltaFType                = 11;
  DeltaFLength              = 16;
  DeltaFDec                 = 17;

var
  HeaderLength,
  RecordsLength : word;
  TmpBufer      : array[0..pred(SmallBlockLength)] of byte;

function Min(N1,N2 : longint) : longint;
begin
  if N1 >= N2
  then Min := N2
  else Min := N1;
end;

function Int2Str(L : LongInt) : string;
{ Converts an integer to a string}
var
  S : string;

begin
  Str(L, S);
  Int2Str := S;
end; { Int2Str }

procedure RandAssign(var F : file);
var
  H,M,S,D : word;
  FN      : string;
begin
  GetTime(H,M,S,D);
  FN := Int2Str(H)+Int2Str(M)+Int2Str(S)+Int2Str(D)+'.tmp';
  assign(F,FN);
end;

function Str2Int(S : string) : LongInt;
{ Converts a string to an integer,errors ignored}
var
  L : LongInt;
  code : integer;
begin
  Val(S,L,code);
  Str2Int := L;
end; { Str2Int }

procedure SetDBError (ErrN : word);
begin
  DBError := ErrN;
  if (not UserErrorHandler) then
  begin
    TextMode(Co80);
    ClrScr;
    write(^G);
    write(^G);
    writeln('Error : ',DBErrMsg(DBError));
    Halt(1);
  end;
end;

procedure ReadRecord(var DBDescr : DBD;RecN : longint);
begin
	with DBDescr do
	begin
		Seek(TmpFile,pred(RecN)*RecSize);
		BlockRead(TmpFile,CurRec^,RecSize);
		CurRecNumber := RecN;
	end;
end;

procedure WriteRecord(var DBDescr : DBD;RecN : longint);
begin
	with DBDescr do
	begin
		Seek(TmpFile,pred(RecN)*RecSize);
		BlockWrite(TmpFile,CurRec^,RecSize);
	end;
end;

function DBResult : word;
begin
  DBResult := DBError;
  DBError := 0;
end;

function DBErrMsg(DBErr : word) : string;
begin
  case DBErr of
    1   : DBErrMsg := '訡 N 1';
    100 : DBErrMsg := ' 墠⠥ ';
    101 : DBErrMsg := 'ᮮ⢥⢨ ⨯ ';
    102 : DBErrMsg := 'Not DB3 file';
    103 : DBErrMsg := 'Conversion error';
    104 : DBErrMsg := 'Field number out of range';
    105 : DBErrMsg := 'Record number out of range';
    106 : DBErrMsg := 'Try writting empty data base (no fields,no records)';

  else DBErrMsg := '⭠ 訡';
  end;
end;

function GetRecPtr(var DBDescr : DBD;RecN : longint) : RecPtr;
begin
	with DBDescr do
	begin
		if MinRamUsing then
		begin
			if CurRecNumber <> RecN then
			begin
				ReadRecord(DBDescr,RecN);
				CurRecNumber := RecN;
			end;
			GetRecPtr := CurRec;
		end
		else GetRecPtr := DBDescr.RecArrayPtr^[RecN];
	end;
end;

procedure PutRecPtr(var DBDescr : DBD;RecN : longint;RPtr : RecPtr);
begin
	with DBDescr do
	begin
		if MinRamUsing then WriteRecord(DBDescr,RecN)
		else DBDescr.RecArrayPtr^[RecN] := RPtr;
	end;
end;

function GetMarker(var DBDescr : DBD;RecN : longint) : byte;
begin
	GetMarker := GetRecPtr(DBDescr,RecN)^[0];
end;

procedure PutMarker(var DBDescr : DBD;RecN : longint;Marker : byte);
var
	CurRecPtr : RecPtr;
begin
	CurRecPtr     := GetRecPtr(DBDescr,RecN);
	CurRecPtr^[0] := Marker;
	PutRecPtr(DBDescr,RecN,CurRecPtr);
end;

procedure Sort(var DBDescr : DBD);
{
Sorting records is moving deleted records (TotalRecs-UsedRecs)
to end of RecArrayPtr
or otherwise deleting fragmentation
}
var
  FirstDel,                     {First deleted record in data base}
  FirstDRB : longint;           {First deleted record in the block of
                                 deleted records at the end of data
                                 base (deleted records block = DRB)}
	TotRecs 		: longint;
	Finding 		: boolean;
	SaveRecPtr 	: RecPtr;
	i						: longint;
begin
  TotRecs  := GetMaxRec(DBDescr);
  FirstDel := 1;
  FirstDRB := TotRecs;
  repeat {finding fragmentation and correct problem until no one encounted}
    {At the begining let's find first deleted record}
    Finding := false;
    repeat
      if GetMarker(DBDescr,FirstDel) = RecordDeleted then Finding := true;
      inc(FirstDel);
    until ((FirstDel > TotRecs) or Finding);
    if (not Finding) then exit;{no deleted records found}
		dec(FirstDel);
    {Next find start of DRB}
    Finding := false;
    repeat
      if GetMarker(DBDescr,FirstDRB) = RecordPresent then Finding := true;
      dec(FirstDRB);
    until ((FirstDRB < 1) or Finding);
		if (not Finding) then exit;{no presented records found}

		{We found last present record,then
    set FirstDRB to begin of DRB}
		inc(FirstDRB);
		if (FirstDRB = pred(FirstDel)) then exit; { no fragmentation encounted}

		if DBDescr.MinRamUsing then

		begin
			for i := 1 to FirstDRB-FirstDel do
			begin
				SaveRecPtr := GetRecPtr(DBDescr,FirstDel+i);
				PutRecPtr(DBDescr,FirstDel+pred(i),SaveRecPtr);
			end;
			PutMarker(DBDescr,FirstDRB,RecordDeleted);
		end

		else
		begin
			{now move deleted record to the begin of DRB}
			{Save moving record pointer ...}
			SaveRecPtr := GetRecPtr(DBDescr,FirstDel);
			{shift all record pointers from FirstDel
			to pred(FirstDRB) at one position up}
			move(GetRecPtr(DBDescr,succ(FirstDel))^,
					 GetRecPtr(DBDescr,FirstDel)^,
					 SizeOf(RecPtr)*(pred(FirstDRB)-FirstDel));

			{.. and put moving record pointer to new place}
			PutRecPtr(DBDescr,pred(FirstDRB),SaveRecPtr);
		end;
  until false;
end;

procedure ReadDB(var DBDescr : DBD;DBFile : string;MinRamUse : boolean);
var
  DBF    : file;
  i,
  j      : word;

procedure AbortWithRelease(ALevel : byte;Count : longint);
var
  i : longint;
begin
  if ALevel >= 2
  then with DBDescr do FreeMemCheck(FieldDArrayPtr,SizeOf(FieldD)*TotalFields);
  if ALevel = 3
  then with DBDescr do
  for i := 1 to Count do FreeMemCheck(RecArrayPtr^[i],RecSize);
  SetDBError(100);
end;

begin
  assign(DBF,DBFile);
  {$I-}
  reset(DBF,1);
  {$I+}
  if IOResult <> 0 then
  begin
    SetDBError(IOResult);
    exit;
  end;

  BlockRead(DBF,TmpBufer,SmallBlockLength);

  if (TmpBufer[0] and $7F) <> DB3Id then
  begin
    SetDBError(102);
    exit;
  end;

  with DBDescr do
  begin
    TotalRecs   := longint(Addr(TmpBufer[DeltaTotalRecs])^);
    MinRamUsing := MinRamUse;
    with LastUpdate do
    begin
      MM := TmpBufer[DeltaDate];
      DD := TmpBufer[DeltaDate+1];
      YY := TmpBufer[DeltaDate+2];
    end;
  end;
  HeaderLength  := word(Addr(TmpBufer[DeltaHeaderLength])^);
  RecordsLength := word(Addr(TmpBufer[DeltaRecordsLength])^);

  {Read Field Descriptors one to one}
  {Count number of record fields}
  DBDescr.TotalFields := 0;
  repeat
    BlockRead(DBF,TmpBufer,SmallBlockLength);
    inc(DBDescr.TotalFields);
  until (TmpBufer[0] = EndOfFields);
  dec(DBDescr.TotalFields);

  {Reserve Space for Field Descriptors}
  with DBDescr do
  begin
    if (not GetMemCheck(FieldDArrayPtr,SizeOf(FieldD)*TotalFields)) then
    begin
      AbortWithRelease(1,0);
      exit;
    end;
  end;

  {Read Field Descriptors one to one}
  Seek(DBF,SmallBlockLength);
  with DBDescr do
  begin
    RecSize := 1;  {Each record start with deleted(*)/present( ) marker}
    for i := 1 to TotalFields do
    with FieldDArrayPtr^[i] do
    begin
      BlockRead(DBF,TmpBufer,SmallBlockLength);
      {Get Field Name}
      FName := '';
      j := 0;
      while TmpBufer[j] <> 0 do
      begin
        FName := FName + chr(TmpBufer[j]);
        inc(j);
      end;
      FType   := FieldType(pred(Pos(chr(TmpBufer[DeltaFType]),FieldStrType)));
      FLength := TmpBufer[DeltaFLength];
      inc(RecSize,FLength);
      FDec    := TmpBufer[DeltaFDec];
    end;
  end;

  {Set file pointer on first record }
  Seek(DBF,HeaderLength);

  if (not DBDescr.MinRamUsing) then
  {...and reserve space for array of pointers on records...}
  if (not GetMemCheck(DBDescr.RecArrayPtr,DBDescr.TotalRecs*SizeOf(RecPtr))) then
  begin
    AbortWithRelease(2,0);
    exit;
  end;

  with DBDescr do
  begin
    if MinRamUsing then
    begin
      RandAssign(TmpFile);
			rewrite(TmpFile,1);
      if not GetMemCheck(CurRec,RecSize) then
      begin
        SetDBError(100);
        exit;
      end;
      CurRecNumber := -1;
    end;
    {...and for records too.}
    UsedRecs := 0;
    for i := 1 to TotalRecs do
    begin
      if MinRamUsing then
      begin
        BlockRead(DBF,CurRec^,RecSize);
				WriteRecord(DBDescr,i);
      end
      else
      begin
        if (not GetMemCheck(RecArrayPtr^[i],RecSize)) then
        begin
          AbortWithRelease(3,i-1);
          exit;
        end;
        BlockRead(DBF,RecArrayPtr^[i]^,RecSize);
      end;
      if (GetMarker(DBDescr,i) = RecordPresent) then inc(UsedRecs);
    end;
  end;
  Close(DBF);
  Sort(DBDescr);
end;

procedure WriteDB(var DBDescr : DBD; DBFile : string);
const
  NullWord : word = $0;
var
  DBF     : file;
  i       : longint;
  RPtr    : RecPtr;
begin
  with DBDescr do
  begin
    if (UsedRecs = 0) and (TotalFields = 0) then
    begin
      SetDBError(106);
      exit;
    end;

    {forming header (see DBase III file structure)}
    FillChar(TmpBufer,SmallBlockLength,chr(0));
    TmpBufer[0] := DB3Id;
    with LastUpdate do
    begin
			TmpBufer[DeltaDate  ] := YY;
			TmpBufer[DeltaDate+1] := MM;
			TmpBufer[DeltaDate+2] := DD;
    end;
    longint(Addr(TmpBufer[DeltaTotalRecs    ])^) := UsedRecs;
    word   (Addr(TmpBufer[DeltaHeaderLength ])^) := succ(succ(TotalFields)*32);{header length}
    word   (Addr(TmpBufer[DeltaRecordsLength])^) := RecSize;                   {records length}

    assign(DBF,DBFile);
		{I-}
    rewrite(DBF,1);
    {$I+}
    if IOResult <> 0 then
    begin
      SetDBError(IOResult);
      Exit;
    end;
    BlockWrite(DBF,TmpBufer,SmallBlockLength);

    for i := 1 to TotalFields do
    with FieldDArrayPtr^[i] do
    begin
      FillChar(TmpBufer,SmallBlockLength,chr(0));
      move(Addr(FName[1])^,TmpBufer,length(FName));   {Field Name}
      TmpBufer[DeltaFType] := byte(FieldStrType[succ(ord(FType))]); {Field Type}
      TmpBufer[DeltaFLength] := FLength;
      TmpBufer[DeltaFDec] := FDec;
      BlockWrite(DBF,TmpBufer,SmallBlockLength);
    end;

    BlockWrite(DBF,EndOfFields,1);

    {Now header is written,let write contents of records}

    for i := 1 to UsedRecs do {Not write deleted records}
    begin
      RPtr := GetRecPtr(DBDescr,i);
      BlockWrite(DBF,RPtr^,RecSize);
    end;
  end;
  BlockWrite(DBF,EndOfFile,1);
  close(DBF);
end;

procedure WriteUpDate(var DBDescr : DBD);
var
  Year,
  Month,
  Day,
  WDay : word;
begin
  GetDate(Year,Month,Day,WDay);
  with DBDescr.LastUpdate do
  begin
    YY := Year mod 100;
    MM := Month;
    DD := Day;
  end;
end;

procedure ReAssign(var F1,F2 : file);
begin
	close(F1);
	erase(F1);
	close(F2);
	assign(F1,FileRec(F2).Name);
	reset(F1,1);
end;

procedure CreateDB(var DBDescr 		: DBD;
											 TotRecs 		: longint;
											 var FieldDescr : FieldD;
                       MinRamUse  : boolean);
var
  i : longint;
begin
  with DBDescr do
  begin
		MinRamUsing := MinRamUse;
		WriteUpdate(DBDescr);
    TotalRecs := TotRecs; {Reserve space for recs...}
    UsedRecs  := 0;       {...but mark it like unused}
    TotalFields := 1;     {There is one field (FieldDescr) at the beginning}
    RecSize := succ(FieldDescr.FLength);{+Del/Present marker}

    if (not GetMemCheck(FieldDArrayPtr,SizeOf(FieldD))) then
    begin
      SetDBError(100);
      exit;
    end;
    FieldDArrayPtr^[1] := FieldDescr;

		if MinRamUsing then
		begin
			RandAssign(TmpFile);
			rewrite(TmpFile,1);
			if not GetMemCheck(CurRec,RecSize) then
			begin
				SetDBError(100);
				exit;
			end;
			FillChar(CurRec^,RecSize,' ');
			CurRec^[0] := RecordDeleted;
			CurRecNumber := -1;
		end
		else
		if (not GetMemCheck(RecArrayPtr,TotRecs*SizeOf(RecPtr))) then
		begin
			SetDBError(100);
			exit;
		end;
		for i := 1 to TotalRecs do
		begin
			if MinRamUsing then WriteRecord(DBDescr,i)
			else
			begin
				if (not GetMemCheck(RecArrayPtr^[i],RecSize)) then
				begin
					SetDBError(100);
					exit;
				end;
				FillChar(RecArrayPtr^[i]^,RecSize,' ');
			end;
			PutMarker(DBDescr,i,RecordDeleted);
		end;
  end;
end;

procedure RemoveDB{From Memory}(var DBDescr : DBD);
var
  i : longint;
  RPtr : RecPtr;
begin
  with DBDescr do
	begin
		if MinRamUsing then
		begin
			close(TmpFile);
			erase(TmpFile);
		end
		else
		begin
			{1.Release records area}
			for i := 1 to TotalRecs do
			begin
				RPtr := GetRecPtr(DBDescr,i);
				FreeMemCheck(RPtr,RecSize);
			end;
			{2.Release pointers to records area}
			FreeMemCheck(RecArrayPtr,SizeOf(RecPtr)*TotalRecs);
		end;
    {3.Release Field Descriptor area}
    FreeMemCheck(FieldDArrayPtr,SizeOf(FieldD)*TotalFields);
  end;
end;

procedure AddField(var DBDescr : DBD;var FieldDescr : FieldD);
var
	TmpPtr 		 : pointer;
	i      		 : longint;
	NewTmpFile : file;
	NewRecSize : longint;
	CRec   		 : RecPtr;
begin
  {Adding field mean :}
  with DBDescr do
  begin
    {1.Add field descriptor to FieldDescriptorArray,i.e.:}
    {1a.Reserve space for new(increased) F.D.Array}
    if (not GetMemCheck(TmpPtr,succ(TotalFields)*SizeOf(FieldD))) then
    begin
      SetDBError(100);
      exit;
    end;
    {1b.Copy old F.D.Array to new}
    move(FieldDArrayPtr^,TmpPtr^,TotalFields*SizeOf(FieldD));
    {1c.Release old F.D.Array}
    FreeMemCheck(FieldDArrayPtr,TotalFields*SizeOf(FieldD));
    {1d.Reassign pointer}
    FieldDArrayPtr := TmpPtr;
    {1e.Increase TotalFields}
    inc(TotalFields);
    {1f.Add new F.D.}
    FieldDArrayPtr^[TotalFields] := FieldDescr;
		NewRecSize := RecSize+FieldDescr.FLength;

		if MinRamUsing then
		begin
			FreeMemCheck(CurRec,RecSize);
			if not GetMemCheck(CurRec,NewRecSize) then
			begin
				SetDBError(100);
				exit;
			end;
			CurRecNumber := -1;
			RandAssign(NewTmpFile);
			rewrite(NewTmpFile,1);
		end;

    {2.Increase area for each record on value FLength of new Field.
       Steps 2a-2e are equivalent of ones 1a-1e                   }
    for i := 1 to TotalRecs do
		if MinRamUsing then
		begin
			FillChar(CurRec^,NewRecSize,' ');
			CRec := GetRecPtr(DBDescr,i);
			Seek(NewTmpFile,pred(i)*(NewRecSize));
			BlockWrite(NewTmpFile,CurRec^,NewRecSize);
		end
		else
		begin
      {2a.}
			if (not GetMemCheck(TmpPtr,NewRecSize)) then
      begin
        SetDBError(100);
        exit;
      end;
      {2b.}
			FillChar(TmpPtr^,NewRecSize,' ');
      move(RecArrayPtr^[i]^,TmpPtr^,RecSize);
      {2c.}
			FreeMemCheck(RecArrayPtr^[i],RecSize);
      {2d.Reassign pointer}
      RecArrayPtr^[i] := TmpPtr;
      {2e.}
    end;
		inc(RecSize,FieldDescr.FLength);
		if MinRamUsing then ReAssign(TmpFile,NewTmpFile);
  end;
end;

procedure DeleteField(var DBDescr : DBD;FieldN : longint);
var
  i           : longint;
  Moving      : boolean;
  DField      : FieldD;
	ShiftLength : longint;
	CRec				: RecPtr;
	NewTmpFile	: file;
	NewRecSize	: longint;
begin
  {Delete field mean :}
  with DBDescr do
  begin
    if FieldN > TotalFields then
    begin
      SetDBError(104);
      exit;
    end;
    Moving := (FieldN < TotalFields);
    DField := FieldDArrayPtr^[FieldN];

		ShiftLength := 0;
		for i := succ(FieldN) to GetMaxField(DBDescr) do
		inc(ShiftLength,FieldDArrayPtr^[i].FLength);
		{2.Decrease area for each record on value FLength of deleted Field.
       Steps 2a-2c are equivalent of ones 1a-1c                      }

		NewRecSize := RecSize - DField.FLength;

		if MinRamUsing then
		begin
			RandAssign(NewTmpFile);
			rewrite(NewTmpFile,1);
		end;

		for i := 1 to TotalRecs do
		if MinRamUsing then
		begin
			CRec := GetRecPtr(DBDescr,i);
      if Moving then move(GetFieldPtr(DBDescr,i,succ(FieldN))^,
                          GetFieldPtr(DBDescr,i,FieldN)^,
													ShiftLength);
			Seek(NewTmpFile,NewRecSize*pred(i));
			BlockWrite(NewTmpFile,CRec^,NewRecSize);
		end
		else
		begin
      {2a.}
      if Moving then move(GetFieldPtr(DBDescr,i,succ(FieldN))^,
                          GetFieldPtr(DBDescr,i,FieldN)^,
													ShiftLength);
      {2b.}
			FreeMemCheck(RecArrayPtr^[i]^[NewRecSize],DField.FLength);
      {2c.}
    end;
		dec(RecSize,DField.FLength);

		if MinRamUsing then
		begin
			ReAssign(TmpFile,NewTmpFile);
			FreeMemCheck(CurRec^[NewRecSize],DField.FLength);
		end;

    {1.Delete field descriptor from FieldDescriptorArray,i.e.:}
    {1a.if FieldN is not last Field then move all fields to record begin}
    if Moving
    then move(FieldDArrayPtr^[succ(FieldN)],
              FieldDArrayPtr^[FieldN],
              SizeOf(FieldD)*(TotalFields-FieldN));
    {1b.Release deleted field space}
    FreeMemCheck(FieldDArrayPtr^[TotalFields],SizeOf(FieldD));
    {1c.Decrease TotalFields}
    dec(TotalFields);
    if (TotalFields = 0) then FieldDArrayPtr := nil;
  end;
end;

function AddRec(var DBDescr : DBD) : longint;
var
  TmpPtr : pointer;
  i      : longint;
begin
  with DBDescr do
  begin
    {If there is no space from previosly deleted record,so}
    if TotalRecs = UsedRecs then
		begin
    	{heavy - we must reserve space for new record
  	  by the following steps :}
			if MinRamUsing then
      begin
        FillChar(CurRec^,RecSize,' ');
        CurRec^[0] := RecordDeleted;
        CurRecNumber := -1;
        for i := 1 to AddRecFactor do	WriteRecord(DBDescr,UsedRecs+i);
      end
      else
      begin
        {1.Create new RecordArrayPtr}
        if (not GetMemCheck(TmpPtr,SizeOf(RecPtr)*(TotalRecs+AddRecFactor))) then
        begin
          SetDBError(100);
          exit;
        end;
        {2.copy in it contents of old RecordArrayPtr}
        move(RecArrayPtr^,TmpPtr^,SizeOf(RecPtr)*TotalRecs);
        {3.free old RecordArrayPtr}
        FreeMemCheck(RecArrayPtr,SizeOf(RecPtr)*TotalRecs);
        {4.Reassign RecArrayPtr}
        RecArrayPtr := TmpPtr;
        {5.Create and initialise AddRecFactor new records}
        for i := 1 to AddRecFactor do
        begin
          if (not GetMemCheck(RecArrayPtr^[TotalRecs+i],RecSize)) then
          begin
            SetDBError(100);
            exit;
          end;
          FillChar(RecArrayPtr^[TotalRecs+i]^,RecSize,' ');
          PutMarker(DBDescr,TotalRecs+i,RecordDeleted);
        end;
      end;
      {6. Set correct TotalRecs}
      inc(TotalRecs,AddRecFactor);
		end;
    inc(UsedRecs);
    PutMarker(DBDescr,UsedRecs,RecordPresent);

    AddRec := UsedRecs;
  end;
end;

procedure DeleteRec(var DBDescr : DBD;RecN : longint);
begin
  with DBDescr do
  begin
    if RecN > UsedRecs then
    begin
      SetDBError(105);
      exit;
    end;
    PutMarker(DBDescr,RecN,RecordDeleted);
    Dec(UsedRecs);
    Sort(DBDescr);
  end;
end;

function DeltaField(var DBDescr : DBD;FieldN : longint) : longint;
var
  CurDeltaField : longint;
  i : longint;
  CurFieldD : FieldD;
begin
  CurDeltaField := 1; { First byte of each record is marker present/deleted record}
  for i := 1 to pred(FieldN) do
  begin
    CurFieldD := GetFieldDPtr(DBDescr,i)^;
    inc(CurDeltaField,CurFieldD.FLength);
  end;
  DeltaField := CurDeltaField;
end;

function GetFieldPtr(var DBDescr : DBD;RecN : longint;FieldN : longint) : FieldPtr;
var
	CRec : RecPtr;
begin
	CRec := GetRecPtr(DBDescr,RecN);
	GetFieldPtr := Addr(CRec^[DeltaField(DBDescr,FieldN)]);
end;

function GetFieldDPtr(var DBDescr : DBD;FieldN : longint) : FieldDPtr;
begin
  GetFieldDPtr := Addr(DBDescr.FieldDArrayPtr^[FieldN]);
end;

function GetMaxRec(var DBDescr : DBD) : longint;
begin
  GetMaxRec := DBDescr.TotalRecs;
end;

function GetMaxField(var DBDescr : DBD) : longint;
begin
  GetMaxField := DBDescr.TotalFields;
end;

function GetField(var DBDescr : DBD;RecN : longint;FieldN : longint) : string;
var
	TmpVar  : CType;
	FPtr    : FieldPtr;
	FDPtr   : FieldDptr;
begin
	FPtr := GetFieldPtr(DBDescr,RecN,FieldN);
	FDPtr := GetFieldDPtr(DBDescr,FieldN);
  byte(TmpVar[0]) := FDPtr^.FLength;
  move(FPtr^,addr(TmpVar[1])^,FDPtr^.FLength);
	GetField := TmpVar;
end;

function GetRField(var DBDescr : DBD;RecN : longint;FieldN : longint) : real;
var
  TmpN   : NType;
  TmpR   : real;
  code   : integer;
begin
	TmpN := GetField(DBDescr,RecN,FieldN);
  Val(TmpN,TmpR,code);
  if code <> 0 then
  begin
    SetDBError(103);
    exit;
  end;
  GetRField := TmpR;
end;

function GetBField(var DBDescr : DBD;RecN : longint;FieldN : longint) : boolean;
var
  TmpL  : LType;
begin
	TmpL := GetField(DBDescr,RecN,FieldN);
  if UpCase(TmpL[1]) in ['Y','T']
  then GetBField := true
  else GetBField := false;
end;

function GetDField(var DBDescr : DBD;RecN : longint;FieldN : longint) : DType;
var
	TmpD  : DType;
begin
	GetDField := GetField(DBDescr,RecN,FieldN);
end;

procedure PutField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : string);
var
  FPtr    : FieldPtr;
  FDPtr   : FieldDPtr;
  RPtr    : RecPtr;
begin
  RPtr := GetRecPtr(DBDescr,RecN);
  FPtr := GetFieldPtr(DBDescr,RecN,FieldN);
	FDPtr := GetFieldDPtr(DBDescr,FieldN);
	FillChar(FPtr^, FDPtr^.Flength, ' ');
  move(addr(Field[1])^,FPtr^,Min(FDPtr^.FLength,length(Field)));
  PutRecPtr(DBDescr,RecN,RPtr);
end;

procedure PutRField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : real);
var
  FDPtr   : FieldDPtr;
  TmpN    : NType;
begin
  FDPtr := GetFieldDPtr(DBDescr,FieldN);
  str(Field : FDPtr^.FLength : FDPtr^.FDec,TmpN);
	PutField(DBDescr,RecN,FieldN,TmpN);
end;

procedure PutDField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : DType);
var
  FDPtr   : FieldDPtr;
	TmpD    : DType;
begin
	PutField(DBDescr,RecN,FieldN,Field);
end;

procedure PutBField(var DBDescr : DBD;RecN : longint;FieldN : longint;Field : boolean);
var
  TmpL     : LType;
begin
  if Field
  then TmpL := 'T'
  else TmpL := 'F';
	PutField(DBDescr,RecN,FieldN,TmpL);
end;

function CheckFieldD(var FD : FieldD) : boolean;
var
  Res : boolean;
begin
  Res := false;
  with FD do
  begin
    if FType in [C,L,M,D] then FDec := 0;
    case FType of
      C : if FLength in [1,254] then Res := true;
      L : FLength := 1;
      M : FLength := 10;
      D : FLength := 8;
      N : if
          (FLength in [1,19])
          and
          (FDec in [1,15])
          and
          (FLength - FDec >= 2)
          then Res := true;
    end;
  end;
  CheckFieldD := Res;
end;

const
  WS = '*';
  SS = '?';

{$F+}
function Optimize(St : string) : string;external;
{$F-}
{$L DB3TOOL}

procedure OptimizePat(var SourcePat : Patrn);
{ Optimize Pattern means processing two or more contiguos WildCards
  like this :
  1) "**" is replaced by one "*"
  2) "*?" is swapped like "?*"
  Result in this procedure is that "*" can't be followed "*" or "?"
  (It's more easy way to process By Mask Comparing)
}

var
  i       : byte;
  SPtr    : ^string;
begin
  if (Not (SourcePat.CFType in [C,D])) then exit;
  SourcePat.CP := Optimize(SourcePat.CP);
(*
  SPtr := Addr(SourcePat.CP);
  i := 1;
  while (i < byte(SPtr^[0])) do
  begin
    if (SPtr^[i] = WS) then
    case SPtr^[succ(i)] of
      WS :
      begin
        delete(SPtr^,i,1);
        dec(i);
      end;

      SS :
      begin
        SPtr^[i]    := SS;
        SPtr^[succ(i)] := WS;
      end;
    end;
    inc(i);
  end;
*)
end;

procedure CreateMask(var MD : MaskD;var Pat : Patrn);
begin
  with MD do
  begin
    if (not GetMemCheck(PatrnAPtr,SizeOf(Patrn))) then
    begin
      SetDBError(100);
      exit;
    end;
    DBPtr         := nil;
    StartRec      := 1;
    TotalPatrn    := 1;
    OptimizePat(Pat);
    PatrnAPtr^[1] := Pat;
  end;
end;

procedure DeleteMask(var MD : MaskD);
begin
  with MD do
  begin
    FreeMemCheck(PatrnAPtr,SizeOf(Patrn)*TotalPatrn);
    TotalPatrn := 0;
    DBPtr      := nil;
  end;
end;

procedure AddPatrn(var MD : MaskD;var Pat : Patrn);
var
  TmpPtr : pointer;
begin
  with MD do
  begin
    if (not GetMemCheck(TmpPtr,SizeOf(Patrn)*succ(TotalPatrn))) then
    begin
      SetDBError(100);
      exit;
    end;
    move(PatrnAPtr^,TmpPtr^,SizeOf(Patrn)*TotalPatrn);
		FreeMemCheck(PatrnAPtr,SizeOf(Patrn)*TotalPatrn);
    PatrnAPtr := TmpPtr;
    inc(TotalPatrn);
    OptimizePat(Pat);
    PatrnAPtr^[TotalPatrn] := Pat;
  end;
end;

{$F+}
function WildEqStr(W,S : string) : boolean;external;
{$F-}
(*
var
  Res : boolean;
  Tmp,
  Wi,
  Si,
  Wl,
  Sl  : byte;
begin
  Res := true;
  WildEqStr := true;
  Wl  := length(W);
  Sl  := length(S);
  Wi  := 1;
  Si  := 1;

  while Res
        and
        ((Wl-Wi) <= (Sl-Si))
        and
        (Wl >= Wi) do
  begin
    if (W[Wi] = SS) then
    {  WildCard p⨫ "?" }
    begin
      inc(Wi);
      inc(Si);
    end
    else
    if (W[Wi] = WS) then
    {  WildCard p⨫ "*" }
    begin
      if (Wi = Wl) then exit;
      inc(Wi);
      { 쬥  WildCard ᫥騩  "*"  }
      {   ⠪    String ᫥ Si ? }
      Tmp := Pos(W[Wi],Copy(S,Si,succ(Sl-Si)));
      if Tmp = 0
      then Res := false
      else
      begin
        inc(Si,pred(Tmp));
        inc(Si);
        inc(Wi);
      end;
    end
    else
    begin
      Res := W[Wi] = S[Si];
      inc(Si);
      inc(Wi);
    end;
  end;
  if (Wl <> pred(Wi)) or (Sl <> pred(Si)) then Res := false;
  WildEqStr := Res;
end;
*)

function  FindNextRecord  (var MD : MaskD) : longint;
var
  i,
  j       : byte;
  Find     : boolean;
  FieldsOk : boolean;
  RecN     : longint;
  PatrnN   : byte;
  TestN    : real;
  TestC    : CType;
  TestD    : DType;
begin
  RecN := 0;
  Find := false;
  with MD,DBPtr^ do
  {    }
	while (not Find) and (UsedRecs >= StartRec) do
  begin
		FieldsOk := true;
    PatrnN  := 1;
    {      }
    while FieldsOk and (TotalPatrn >= PatrnN) do
    begin
      { pp  StartRec  p PatrnN }
      with PatrnAPtr^[PatrnN] do
      case CFType of

        L :
        FieldsOk := GetBField(DBPtr^,StartRec,CFieldN) = LP;

        N :
        begin
          TestN := GetRField(DBPtr^,StartRec,CFieldN);
          FieldsOk := (TestN >= NP[1]) and (TestN <= NP[2]);
        end;

				D,C :
				FieldsOk := WildEqStr(DP,GetField(DBPtr^,StartRec,CFieldN));

      end;
      inc(PatrnN);
    end;
    if FieldsOk then
    begin
      Find := true;
      RecN := StartRec;
    end;
    inc(StartRec);
  end;
  FindNextRecord := RecN;
end;

function  FindFirstRecord (var MD : MaskD;var DBDescr : DBD) : longint;
begin
  if (DBDescr.TotalRecs < 1) or (DBDescr.TotalFields < 1)
  then FindFirstRecord := 0
  else
  with MD do
  begin
    DBPtr     := Addr(DBDescr);
    StartRec  := 1;
    FindFirstRecord := FindNextRecord(MD);
  end;
end;

end.

